Virtual Hubs - Get Effective Virtual Hub Routes

Gets the effective routes configured for the Virtual Hub resource or the specified resource .

POST https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/virtualHubs/{virtualHubName}/effectiveRoutes?api-version=2025-05-01

URI Parameters

Name In Required Type Description
resourceGroupName
path True

string

minLength: 1
maxLength: 90

The name of the resource group. The name is case insensitive.

subscriptionId
path True

string (uuid)

The ID of the target subscription. The value must be an UUID.

virtualHubName
path True

string

The name of the VirtualHub.

api-version
query True

string

minLength: 1

The API version to use for this operation.

Request Body

Name Type Description
resourceId

string

The resource whose effective routes are being requested.

virtualWanResourceType

string

The type of the specified resource like RouteTable, ExpressRouteConnection, HubVirtualNetworkConnection, VpnConnection and P2SConnection.

Responses

Name Type Description
200 OK

VirtualHubEffectiveRouteList

Azure operation completed successfully.

202 Accepted

Resource operation accepted.

Headers

  • Location: string
  • Retry-After: integer
Other Status Codes

Common.CloudError

An unexpected error response.

Security

azure_auth

Azure Active Directory OAuth2 Flow.

Type: oauth2
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/authorize

Scopes

Name Description
user_impersonation impersonate your user account

Examples

Effective Routes for a Connection resource
Effective Routes for a Route Table resource
Effective Routes for the Virtual Hub

Effective Routes for a Connection resource

Sample request

POST https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/virtualHubs/virtualHub1/effectiveRoutes?api-version=2025-05-01

{
  "resourceId": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/resourceGroupName/providers/Microsoft.Network/expressRouteGateways/expressRouteGatewayName/expressRouteConnections/connectionName",
  "virtualWanResourceType": "ExpressRouteConnection"
}

Sample response

{
  "value": [
    {
      "addressPrefixes": [
        "10.147.128.0/17"
      ],
      "asPath": "65520-65520",
      "nextHopType": "Remote Hub",
      "nextHops": [
        "/subscriptions/testSub/resourceGroups/testRg/providers/Microsoft.Network/virtualHubs/hub0"
      ],
      "routeOrigin": "/subscriptions/testSub/resourceGroups/testRg/providers/Microsoft.Network/virtualHubs/hub0"
    },
    {
      "addressPrefixes": [
        "10.0.0.0/16"
      ],
      "asPath": "12076-12076",
      "nextHopType": "ExpressRouteGateway",
      "nextHops": [
        "/subscriptions/testSub/resourceGroups/testRg/providers/Microsoft.Network/expressRouteGateways/ErGw1"
      ],
      "routeOrigin": "/subscriptions/testSub/resourceGroups/testRg/providers/Microsoft.Network/expressRouteGateways/ErGw1"
    }
  ]
}
location: https://management.azure.com/subscriptions/{subscriptionId}/providers/Microsoft.Network/locations/{location}/operationResults/{operationId}?api-version={api-version}

Effective Routes for a Route Table resource

Sample request

POST https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/virtualHubs/virtualHub1/effectiveRoutes?api-version=2025-05-01

{
  "resourceId": "/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/virtualHubs/virtualHub1/hubRouteTables/hubRouteTable1",
  "virtualWanResourceType": "RouteTable"
}

Sample response

{
  "value": [
    {
      "addressPrefixes": [
        "10.147.128.0/17"
      ],
      "asPath": "65520-65520",
      "nextHopType": "Remote Hub",
      "nextHops": [
        "/subscriptions/testSub/resourceGroups/testRg/providers/Microsoft.Network/virtualHubs/hub0"
      ],
      "routeOrigin": "/subscriptions/testSub/resourceGroups/testRg/providers/Microsoft.Network/virtualHubs/hub0"
    },
    {
      "addressPrefixes": [
        "10.0.0.0/16"
      ],
      "asPath": "12076-12076",
      "nextHopType": "ExpressRouteGateway",
      "nextHops": [
        "/subscriptions/testSub/resourceGroups/testRg/providers/Microsoft.Network/expressRouteGateways/ErGw1"
      ],
      "routeOrigin": "/subscriptions/testSub/resourceGroups/testRg/providers/Microsoft.Network/expressRouteGateways/ErGw1"
    }
  ]
}
location: https://management.azure.com/subscriptions/{subscriptionId}/providers/Microsoft.Network/locations/{location}/operationResults/{operationId}?api-version={api-version}

Effective Routes for the Virtual Hub

Sample request

POST https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/rg1/providers/Microsoft.Network/virtualHubs/virtualHub1/effectiveRoutes?api-version=2025-05-01

Sample response

{
  "value": [
    {
      "addressPrefixes": [
        "10.147.128.0/17"
      ],
      "asPath": "65520-65520",
      "nextHopType": "Remote Hub",
      "nextHops": [
        "/subscriptions/testSub/resourceGroups/testRg/providers/Microsoft.Network/virtualHubs/hub0"
      ],
      "routeOrigin": "/subscriptions/testSub/resourceGroups/testRg/providers/Microsoft.Network/virtualHubs/hub0"
    },
    {
      "addressPrefixes": [
        "10.0.0.0/16"
      ],
      "asPath": "12076-12076",
      "nextHopType": "ExpressRouteGateway",
      "nextHops": [
        "/subscriptions/testSub/resourceGroups/testRg/providers/Microsoft.Network/expressRouteGateways/ErGw1"
      ],
      "routeOrigin": "/subscriptions/testSub/resourceGroups/testRg/providers/Microsoft.Network/expressRouteGateways/ErGw1"
    }
  ]
}
location: https://management.azure.com/subscriptions/{subscriptionId}/providers/Microsoft.Network/locations/{location}/operationResults/{operationId}?api-version={api-version}

Definitions

Name Description
Common.CloudError

An error response from the service.

Common.CloudErrorBody

An error response from the service.

EffectiveRoutesParameters

The parameters specifying the resource whose effective routes are being requested.

VirtualHubEffectiveRoute

The effective route configured on the virtual hub or specified resource.

VirtualHubEffectiveRouteList

EffectiveRoutes List.

Common.CloudError

An error response from the service.

Name Type Description
error

Common.CloudErrorBody

Cloud error body.

Common.CloudErrorBody

An error response from the service.

Name Type Description
code

string

An identifier for the error. Codes are invariant and are intended to be consumed programmatically.

details

Common.CloudErrorBody[]

A list of additional details about the error.

message

string

A message describing the error, intended to be suitable for display in a user interface.

target

string

The target of the particular error. For example, the name of the property in error.

EffectiveRoutesParameters

The parameters specifying the resource whose effective routes are being requested.

Name Type Description
resourceId

string

The resource whose effective routes are being requested.

virtualWanResourceType

string

The type of the specified resource like RouteTable, ExpressRouteConnection, HubVirtualNetworkConnection, VpnConnection and P2SConnection.

VirtualHubEffectiveRoute

The effective route configured on the virtual hub or specified resource.

Name Type Description
addressPrefixes

string[]

The list of address prefixes.

asPath

string

The ASPath of this route.

nextHopType

string

The type of the next hop.

nextHops

string[]

The list of next hops.

routeOrigin

string

The origin of this route.

VirtualHubEffectiveRouteList

EffectiveRoutes List.

Name Type Description
value

VirtualHubEffectiveRoute[]

The list of effective routes configured on the virtual hub or the specified resource.